#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file 'MainCoffee.ui'
#
# Created by: PyQt5 UI code generator 5.11.3
#
# WARNING! All changes made in this file will be lost!
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtCore import QTimer, Qt, QSize
import RPi.GPIO as GPIO
import time
import datetime
import requests
import os
import shutil
import json
import pyqrcode
from pyqrcode import QRCode
from io import BytesIO
import subprocess
from urllib.request import urlopen
import urllib.request
import pyspeedtest
import socket
import ApiLaundry

def setRelay(pin):
    GPIO.setmode(GPIO.BCM)
    GPIO.setwarnings(False)
    GPIO.cleanup()
    GPIO.setup(pin, GPIO.OUT)
    GPIO.output(pin, GPIO.HIGH)
    
def setPin(pin1, pin2, pin3, pin4, pin5):
    GPIO.setmode(GPIO.BCM)
    GPIO.setwarnings(False)
    GPIO.cleanup()
    GPIO.setup(pin1, GPIO.OUT)
    GPIO.output(pin1, GPIO.HIGH)
    GPIO.setup(pin2, GPIO.OUT)
    GPIO.output(pin2, GPIO.HIGH)
    GPIO.setup(pin3, GPIO.OUT)
    GPIO.output(pin3, GPIO.HIGH)
    GPIO.setup(pin4, GPIO.OUT)
    GPIO.output(pin4, GPIO.HIGH)
    GPIO.setup(pin5, GPIO.OUT)
    GPIO.output(pin5, GPIO.HIGH)
    
def ConnectRelay(pin):
    GPIO.output(pin, GPIO.LOW)

def DisconnectRelay(pin):
    GPIO.output(pin, GPIO.HIGH)

def CheckFile(file):
    return os.path.isfile(file)

class Ui_Dialog(object):
    def setupUi(self, Dialog):
        self.Scwidth=1024
        self.Scheight=600
        Dialog.setObjectName("Laundry")
        Dialog.resize(self.Scwidth, self.Scheight)
        Dialog.setWindowFlags(QtCore.Qt.FramelessWindowHint)
        Dialog.setWindowState(QtCore.Qt.WindowFullScreen)
        Dialog.setCursor(QtCore.Qt.BlankCursor)
        #Dialog.setWindowIcon(QtGui.QIcon("/home/pi/Documents/OmegaCoffee/coffee.png"))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Preferred, QtWidgets.QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(Dialog.sizePolicy().hasHeightForWidth())
        Dialog.setSizePolicy(sizePolicy)
        Dialog.setStyleSheet("background-color: rgb(192, 192, 192);")
        fontclwhite = "color: rgb(255, 255, 255);"
        fontclblack = "color: rgb(0, 0, 0)"
        self.imageBG=""
        self.imageBGHome=""
        self.imageBGQR=""
        self.imageBGInfo=""
        self.imageBGProgress=""
        self.lblBG = QtWidgets.QLabel(Dialog)
        self.lblBG.setGeometry(QtCore.QRect(0, 0, 1024, 600))
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBG))
        #frame Header
        self.frameHeader = QtWidgets.QFrame(Dialog)
        self.frameHeader.setGeometry(QtCore.QRect(0, 0, self.Scwidth, 160))
        self.frameHeader.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none")
        self.frameHeader.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameHeader.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameHeader.setObjectName("frameHeader")
        self.LogoBtn = QtWidgets.QPushButton(self.frameHeader)
        self.LogoBtn.setGeometry(QtCore.QRect(0, 0, 275, 75))
        self.LogoBtn.setObjectName("LogoBtn")
        self.LogoBtn.clicked.connect(self.LogoClicked)
        self.LogoBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaLaundry/Img/Logo.png); border : none")
        self.InternetBtn = QtWidgets.QPushButton(self.frameHeader)
        self.InternetBtn.setGeometry(QtCore.QRect(self.Scwidth-115, 30, 30, 30))
        self.InternetBtn.setObjectName("InternetBtn")
        self.InternetBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}")
        self.InternetBtn.clicked.connect(self.InternetBtnClicked)
        self.IsInternetClicked=False
        font = QtGui.QFont("Quicksand Medium")
        font.setPointSize(15)
        self.lblExceptionWarning=QtWidgets.QLabel(self.frameHeader)
        self.lblExceptionWarning.setGeometry(QtCore.QRect(self.Scwidth/2+160, 0, 250, 70))
        self.lblExceptionWarning.setFont(font)
        self.lblExceptionWarning.setText("Mohon Tunggu..\nMencari Koneksi")
        self.lblExceptionWarning.setStyleSheet(fontclwhite+" background-color:red;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}")
        self.lblExceptionWarning.setAlignment(QtCore.Qt.AlignRight)
        self.lblExceptionWarning.setObjectName("lblExceptionWarning")
        self.lblExceptionWarning.hide()
        self.lblWaitingPayment=QtWidgets.QLabel(self.frameHeader)
        self.lblWaitingPayment.setGeometry(QtCore.QRect(self.Scwidth/2-125, 0, 250, 70))
        self.lblWaitingPayment.setFont(font)
        self.lblWaitingPayment.setText("Menunggu Pembayaran")
        self.lblWaitingPayment.setStyleSheet(fontclwhite+" background-color:rgb(255, 153, 19);"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}")
        self.lblWaitingPayment.setAlignment(QtCore.Qt.AlignCenter)
        self.lblWaitingPayment.setObjectName("lblWaitingPayment")
        self.lblWaitingPayment.hide()
        self.lblInternetPercent = QtWidgets.QLabel(self.frameHeader)
        self.lblInternetPercent.setGeometry(QtCore.QRect(self.Scwidth-130, 0, 60, 20))
        font = QtGui.QFont("Quicksand Medium")
        font.setPointSize(15)
        self.lblInternetPercent.setFont(font)
        self.lblInternetPercent.setText("...%")
        self.lblInternetPercent.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblInternetPercent.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInternetPercent.setObjectName("lblInternetPercent")
        self.lblInternetPercent.show()
        self.lblVersion=QtWidgets.QLabel(self.frameHeader)
        self.lblVersion.setGeometry(QtCore.QRect(280, 0, 150, 40))
        font = QtGui.QFont("Quicksand Medium")
        font.setPointSize(15)
        self.lblVersion.setFont(font)
        self.lblVersion.setText("V.")
        self.lblVersion.setStyleSheet(fontclwhite)
        self.lblVersion.setAlignment(QtCore.Qt.AlignLeft)
        self.lblVersion.setObjectName("lblVersion")
        self.lblVersion.show()
        #frame Menu
        self.frameMenu = QtWidgets.QFrame(Dialog)
        self.frameMenu.setGeometry(QtCore.QRect(0, 160, self.Scwidth, self.Scheight-160))
        self.frameMenu.setStyleSheet("background-color: rgba(255, 255, 255, 100); border : none")
        self.frameMenu.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameMenu.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameMenu.setObjectName("frameMenu")
        self.MulaiBtn = QtWidgets.QPushButton(self.frameMenu)
        self.MulaiBtn.setGeometry(QtCore.QRect((self.Scwidth-300)/2, 40, 300, 300))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(36)
        self.MulaiBtn.setFont(font)
        self.MulaiBtn.setStyleSheet("border-style: outset; border-width: 5px; border-radius: 0px;"
                                        "border-color: beige;padding: 6px;}")
        self.MulaiBtn.setIcon(QtGui.QIcon("/home/pi/Documents/OmegaLaundry/Img/BtnMulai.jpg"))
        self.MulaiBtn.setIconSize(QSize(300,300))
        #self.MulaiBtn.setStyleSheet("QPushButton {background-color: rgb(250, 125, 36); color: white; border: none;"
                                    #"border-style: outset; border-width: 2px; border-radius: 10px;"
                                    #"border-color: beige;padding: 6px;}"
                                    #"QPushButton:pressed {background-color: blue};")
        self.MulaiBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.MulaiBtn.setObjectName("MulaiBtn")
        self.MulaiBtn.clicked.connect(self.MulaiClick)
        self.lblMulaiBtn = QtWidgets.QLabel(self.MulaiBtn)
        self.lblMulaiBtn.setGeometry(QtCore.QRect(0, 0, 300, 300))
        self.lblMulaiBtn.setStyleSheet("color: red;")
        self.lblMulaiBtn.setAlignment(QtCore.Qt.AlignCenter)
        self.lblMulaiBtn.setObjectName("lblMulaiBtn")
        self.lblMulaiBtn.raise_()
        self.lblMulaiBtn.hide()        
        self.Jasa1Btn = QtWidgets.QPushButton(self.frameMenu)
        self.Jasa1Btn.setGeometry(QtCore.QRect(self.Scwidth/2-350, 40, 300, 300))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(36)
        self.Jasa1Btn.setFont(font)
        self.Jasa1Btn.setStyleSheet("border-style: outset; border-width: 5px; border-radius: 0px;"
                                        "border-color: beige;padding: 6px;}")
        self.Jasa1Btn.setIcon(QtGui.QIcon("/home/pi/Documents/OmegaLaundry/Img/BtnCuci.jpg"))
        self.Jasa1Btn.setIconSize(QSize(300,300))
        #self.Jasa1Btn.setStyleSheet("QPushButton {background-color: rgb(250, 125, 36); color: white; border: none;"
                                    #"border-style: outset; border-width: 2px; border-radius: 10px;"
                                    #"border-color: beige;padding: 6px;}"
                                    #"QPushButton:pressed {background-color: blue};")
        self.Jasa1Btn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.Jasa1Btn.setObjectName("Jasa1Btn")
        self.Jasa1Btn.clicked.connect(self.Jasa1Click)
        self.lblJasa1Btn = QtWidgets.QLabel(self.Jasa1Btn)
        self.lblJasa1Btn.setGeometry(QtCore.QRect(0, 0, 300, 300))
        self.lblJasa1Btn.setStyleSheet("color: red;")
        self.lblJasa1Btn.setAlignment(QtCore.Qt.AlignCenter)
        self.lblJasa1Btn.setObjectName("lblJasa1Btn")
        self.lblJasa1Btn.raise_()
        self.lblJasa1Btn.hide()        
        self.Jasa2Btn = QtWidgets.QPushButton(self.frameMenu)
        self.Jasa2Btn.setGeometry(QtCore.QRect(self.Scwidth/2+50, 40, 300, 300))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(36)
        self.Jasa2Btn.setFont(font)
        self.Jasa2Btn.setStyleSheet("border-style: outset; border-width: 5px; border-radius: 0px;"
                                        "border-color: beige;padding: 6px;}")
        self.Jasa2Btn.setIcon(QtGui.QIcon("/home/pi/Documents/OmegaLaundry/Img/BtnKering.jpg"))
        self.Jasa2Btn.setIconSize(QSize(300,300))
        #self.Jasa2Btn.setStyleSheet("QPushButton {background-color: rgb(250, 125, 36); color: white; border: none;"
                                    #"border-style: outset; border-width: 2px; border-radius: 10px;"
                                    #"border-color: beige;padding: 6px;}"
                                    #"QPushButton:pressed {background-color: blue};")
        self.Jasa2Btn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.Jasa2Btn.setObjectName("Jasa2Btn")
        self.Jasa2Btn.clicked.connect(self.Jasa2Click)
        self.lblJasa2Btn = QtWidgets.QLabel(self.Jasa2Btn)
        self.lblJasa2Btn.setGeometry(QtCore.QRect(0, 0, 300, 300))
        self.lblJasa2Btn.setStyleSheet("color: red;")
        self.lblJasa2Btn.setAlignment(QtCore.Qt.AlignCenter)
        self.lblJasa2Btn.setObjectName("lblJasa2Btn")
        self.lblJasa2Btn.raise_()
        self.lblJasa2Btn.hide() 
        #frame Progress
        self.frameProgress = QtWidgets.QFrame(Dialog)
        self.frameProgress.setGeometry(QtCore.QRect(0, 160, self.Scwidth, self.Scheight-160))
        self.frameProgress.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none")
        self.frameProgress.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameProgress.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameProgress.setObjectName("frameProgress")
        self.lblInfoProgress = QtWidgets.QLabel(self.frameProgress)
        self.lblInfoProgress.setGeometry(QtCore.QRect(5, 5, self.Scwidth-10, 300))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(24)
        self.lblInfoProgress.setFont(font)
        self.lblInfoProgress.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblInfoProgress.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInfoProgress.setObjectName("lblInformation2")
        self.ProgressBackBtn = QtWidgets.QPushButton(self.frameProgress)
        self.ProgressBackBtn.setGeometry(QtCore.QRect(200, 320, 624, 80))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(28)
        self.ProgressBackBtn.setFont(font)
        self.ProgressBackBtn.setStyleSheet("QPushButton {background-color: rgb(250, 125, 36); color: white; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.ProgressBackBtn.setObjectName("NextCupBtn")
        self.ProgressBackBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        #self.ProgressBackBtn.clicked.connect(self.CancelPayment)
        self.ProgressBackBtn.hide()
        self.frameProgress.hide()
        #frame Payment        
        self.framePayment = QtWidgets.QFrame(Dialog)
        self.framePayment.setGeometry(QtCore.QRect(0, 160, self.Scwidth, self.Scheight-160))
        self.framePayment.setStyleSheet("background-color: rgba(255, 255, 255, 100); border : none")
        self.framePayment.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.framePayment.setFrameShadow(QtWidgets.QFrame.Raised)
        self.framePayment.setObjectName("framePayment")
        self.LaundromatBtn = QtWidgets.QPushButton(self.framePayment)
        self.LaundromatBtn.setGeometry(QtCore.QRect(self.Scwidth/2-350, 20, 300, 300))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(36)
        self.LaundromatBtn.setFont(font)
        self.LaundromatBtn.setStyleSheet("border-style: outset; border-width: 5px; border-radius: 0px;"
                                        "border-color: beige;padding: 6px;}")
        self.LaundromatBtn.setIcon(QtGui.QIcon("/home/pi/Documents/OmegaLaundry/Img/BtnLaundromart.jpg"))
        self.LaundromatBtn.setIconSize(QSize(300,300))
        #self.LaundromatBtn.setStyleSheet("QPushButton {background-color: rgb(250, 125, 36); color: white; border: none;"
                                    #"border-style: outset; border-width: 2px; border-radius: 10px;"
                                    #"border-color: beige;padding: 6px;}"
                                    #"QPushButton:pressed {background-color: blue};")
        self.LaundromatBtn.setObjectName("LaundromatBtn")
        self.LaundromatBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.lblLaundromatBtn = QtWidgets.QLabel(self.MulaiBtn)
        self.lblLaundromatBtn.setGeometry(QtCore.QRect(0, 0, 300, 300))
        self.lblLaundromatBtn.setStyleSheet("color: red;")
        self.lblLaundromatBtn.setAlignment(QtCore.Qt.AlignCenter)
        self.lblLaundromatBtn.setObjectName("lblLaundromatBtn")
        self.lblLaundromatBtn.raise_()
        self.lblLaundromatBtn.hide()        
        self.LaundromatBtn.clicked.connect(self.LaundromatClick)
        self.QrisBtn = QtWidgets.QPushButton(self.framePayment)
        self.QrisBtn.setGeometry(QtCore.QRect(self.Scwidth/2+50, 20, 300, 300))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(36)
        self.QrisBtn.setFont(font)
        self.QrisBtn.setStyleSheet("border-style: outset; border-width: 5px; border-radius: 0px;"
                                        "border-color: beige;padding: 6px;}")
        self.QrisBtn.setIcon(QtGui.QIcon("/home/pi/Documents/OmegaLaundry/Img/BtnQris.jpg"))
        self.QrisBtn.setIconSize(QSize(300,300))
        #self.QrisBtn.setStyleSheet("QPushButton {background-color: rgb(250, 125, 36); color: white; border: none;"
                                    #"border-style: outset; border-width: 2px; border-radius: 10px;"
                                    #"border-color: beige;padding: 6px;}"
                                    #"QPushButton:pressed {background-color: blue};")
        self.QrisBtn.setObjectName("QrisBtn")
        self.QrisBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.QrisBtn.clicked.connect(self.QrisClick)
        self.lblQrisBtn = QtWidgets.QLabel(self.MulaiBtn)
        self.lblQrisBtn.setGeometry(QtCore.QRect(0, 0, 300, 300))
        self.lblQrisBtn.setStyleSheet("color: red;")
        self.lblQrisBtn.setAlignment(QtCore.Qt.AlignCenter)
        self.lblQrisBtn.setObjectName("lblQrisBtn")
        self.lblQrisBtn.raise_()
        self.lblQrisBtn.hide() 
        self.CancelBtn = QtWidgets.QPushButton(self.framePayment)
        self.CancelBtn.setGeometry(QtCore.QRect((self.Scwidth-320)/2, 340, 320, 90))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(36)
        self.CancelBtn.setFont(font)
        self.CancelBtn.setStyleSheet("QPushButton {background-color: rgb(250, 125, 36); color: white; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.CancelBtn.setObjectName('CancelBtn')
        self.CancelBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.CancelBtn.clicked.connect(self.CancelClick)
        self.framePayment.hide()
        #frame SinglePayment        
        self.frameSinglePayment = QtWidgets.QFrame(Dialog)
        self.frameSinglePayment.setGeometry(QtCore.QRect(0, 160, self.Scwidth, self.Scheight-160))
        self.frameSinglePayment.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none")
        self.frameSinglePayment.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameSinglePayment.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameSinglePayment.setObjectName("frameSinglePayment")
        self.lblInfoTimer = QtWidgets.QLabel(self.frameSinglePayment)
        self.lblInfoTimer.setGeometry(QtCore.QRect(0, 310, 50, 20))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(12)
        self.lblInfoTimer.setFont(font)
        self.lblInfoTimer.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblInfoTimer.setAlignment(QtCore.Qt.AlignLeft)
        self.lblInfoTimer.setObjectName("lblInfoTimer")
        self.lblInfoTimer.hide()
        self.webSingleQR = QtWebKitWidgets.QWebView(self.frameSinglePayment)
        self.webSingleQR.setGeometry(QtCore.QRect((self.Scwidth-330)/2, 0, 330, 330))
        self.webSingleQR.setUrl(QtCore.QUrl("http://www.google.com/"))
        self.webSingleQR.setObjectName("webSingleQR")
        self.webSingleQR.hide()
        self.CancelSinglePaymentBtn = QtWidgets.QPushButton(self.frameSinglePayment)
        self.CancelSinglePaymentBtn.setGeometry(QtCore.QRect((self.Scwidth-624)/2, 330, 624, 80))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setFamily("Sans Serif")
        font.setPointSize(28)
        self.CancelSinglePaymentBtn.setFont(font)
        self.CancelSinglePaymentBtn.setStyleSheet("QPushButton {background-color: rgb(250, 125, 36); color: white; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.CancelSinglePaymentBtn.setObjectName("CancelSinglePaymentBtn")
        self.CancelSinglePaymentBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.CancelSinglePaymentBtn.clicked.connect(self.CancelClick)
        self.lblQRSingle = QtWidgets.QLabel(self.frameSinglePayment)
        self.lblQRSingle.setGeometry(QtCore.QRect(347, 0, 330, 330))
        self.lblQRSingle.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.lblQRSingle.setText("")
        self.lblQRSingle.setObjectName("lblQRSingle")
        self.lblQRSingle.hide()
        self.frameSinglePayment.hide()        
        #frame Information
        self.frameInformation = QtWidgets.QFrame(Dialog)
        self.frameInformation.setGeometry(QtCore.QRect(0, 160, self.Scwidth, self.Scheight-160))
        self.frameInformation.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none")
        self.frameInformation.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameInformation.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameInformation.setObjectName("frameInformation")
        self.lblInformation = QtWidgets.QLabel(self.frameInformation)
        self.lblInformation.setGeometry(QtCore.QRect(5, 0, self.Scwidth-10, 240))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(30)
        self.lblInformation.setFont(font)
        self.lblInformation.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblInformation.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInformation.setObjectName("lblInformation")
        self.BackToMainBtn = QtWidgets.QPushButton(self.frameInformation)
        self.BackToMainBtn.setGeometry(QtCore.QRect((self.Scwidth-624)/2, 330, 624, 80))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(28)
        self.BackToMainBtn.setFont(font)
        self.BackToMainBtn.setStyleSheet("QPushButton {background-color: rgb(250, 125, 36); color: white; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.BackToMainBtn.setObjectName("BackToMainBtn")
        self.BackToMainBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.BackToMainBtn.clicked.connect(self.CancelClick)
        self.frameInformation.hide()        
        #frame Login
        self.frameLogin = QtWidgets.QFrame(Dialog)
        tmpfont = QtGui.QFont()
        tmpfont.setFamily("Quicksand Medium")
        tmpfont.setPointSize(12)
        self.frameLogin.setGeometry(QtCore.QRect(0, 0, self.Scwidth, 300))
        self.frameLogin.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameLogin.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameLogin.setObjectName("frameLogin")
        self.frameLogin.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameLogin.hide()
        self.widget = QtWidgets.QWidget(self.frameLogin)
        #self.widget.setGeometry(QtCore.QRect(30, 30, 550, 111))
        self.widget.setGeometry(QtCore.QRect((self.Scwidth-550)/2, 60, 550, 120))
        self.widget.setObjectName("widget")
        self.gridLayout = QtWidgets.QGridLayout(self.widget)
        self.gridLayout.setContentsMargins(0, 0, 0, 0)
        self.gridLayout.setObjectName("gridLayout")
        self.lblUserID = QtWidgets.QLabel(self.widget)
        self.lblUserID.setFont(tmpfont)
        self.lblUserID.setObjectName("lblUserID")
        self.gridLayout.addWidget(self.lblUserID, 0, 0, 1, 1)
        self.lineUserID = QtWidgets.QLineEdit(self.widget)
        self.lineUserID.setFont(tmpfont)
        self.lineUserID.setObjectName("lineUserID")
        self.lineUserID.returnPressed.connect(self.LoginClicked)
        self.gridLayout.addWidget(self.lineUserID, 0, 1, 1, 1)
        self.lblPassword = QtWidgets.QLabel(self.widget)
        self.lblPassword.setFont(tmpfont)
        self.lblPassword.setObjectName("lblPassword")
        self.gridLayout.addWidget(self.lblPassword, 1, 0, 1, 1)
        self.linePassword = QtWidgets.QLineEdit(self.widget)
        self.linePassword.setFont(tmpfont)
        self.linePassword.setObjectName("linePassword")
        self.linePassword.setEchoMode(QtWidgets.QLineEdit.Password)
        self.linePassword.returnPressed.connect(self.LoginClicked)
        self.gridLayout.addWidget(self.linePassword, 1, 1, 1, 1)
        self.widget1 = QtWidgets.QWidget(self.frameLogin)
        #self.widget1.setGeometry(QtCore.QRect(572, 210, 200, 30))
        self.widget1.setGeometry(QtCore.QRect(self.Scwidth-250, 250, 200, 30))
        self.widget1.setObjectName("widget1")
        self.gridLayout_2 = QtWidgets.QGridLayout(self.widget1)
        self.gridLayout_2.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_2.setObjectName("gridLayout_2")
        self.CancelLoginBtn = QtWidgets.QPushButton(self.widget1)
        self.CancelLoginBtn.setFont(tmpfont)
        self.CancelLoginBtn.setObjectName("CancelLoginBtn")
        self.CancelLoginBtn.clicked.connect(self.LogoClicked)
        self.CancelLoginBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.gridLayout_2.addWidget(self.CancelLoginBtn, 0, 0, 1, 1)
        self.LoginBtn = QtWidgets.QPushButton(self.widget1)
        self.LoginBtn.setFont(tmpfont)
        self.LoginBtn.setObjectName("LoginBtn")
        self.LoginBtn.clicked.connect(self.LoginClicked) 
        self.LoginBtn.setFocusPolicy(QtCore.Qt.NoFocus)       
        self.gridLayout_2.addWidget(self.LoginBtn, 0, 1, 1, 1)
        #frame Keyboard
        self.frameKeyboard = QtWidgets.QFrame(Dialog)
        self.frameKeyboard.setGeometry(QtCore.QRect(0, 300, self.Scwidth, self.Scheight-300))
        self.frameKeyboard.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameKeyboard.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameKeyboard.setObjectName("frameKeyboard")
        self.frameKeyboard.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameKeyboard.hide()
        self.buttons=["`", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "-", "=", "<-",
                 "Tab", "q", "w", "e", "r", "t", "y", "u", "i", "o", "p", "[", "]", "Ent",
                 "Caps", "a", "s", "d", "f", "g", "h", "j", "k", "l", ";", ":", "'", "Ctrl",
                 "Shft", "<", "z", "x", "c", "v", "b", "n", "m", ".", ",", "/", ">", "Alt",
                 "Space"]
        self.buttons2=["~", "!", "@", "#", "$", "%", "^", "&", "*", "(", ")", "_", "+", "<-",
                 "Tab", "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", "{", "}", "Ent",
                 "Caps", "A", "S", "D", "F", "G", "H", "J", "K", "L", ";", ":", '"', "Ctrl",
                 "Shft", "<", "Z", "X", "C", "V", "B", "N", "M", ".", ",", "?", ">", "Alt",
                 "Space"]
        self.btn=[]
        self.Pinggir=0
        if self.Scwidth==1024:
            self.Pinggir=87
        elif self.Scwidth==1280:
            self.Pinggir=220
        for x in range(len(self.buttons)) :
            self.btn.append(x)
            self.btn[x]=QtWidgets.QPushButton(self.frameKeyboard)
            txtKey = self.buttons[x]
            self.btn[x].setText(txtKey)
            if txtKey=="Space":
                self.btn[x].setGeometry(QtCore.QRect(self.Pinggir+(x%14*60), 7+(x//14*60), 835, 55))            
            else :
                self.btn[x].setGeometry(QtCore.QRect(self.Pinggir+(x%14*60), 7+(x//14*60), 55, 55))
            self.btn[x].setFocusPolicy(QtCore.Qt.NoFocus)
            self.btn[x].clicked.connect(lambda checked, a=x : self.KeyboardClicked(a))
        self.CapsOn=False
        self.ShiftOn=False
        self.CtrlOn=False
        #frame Setting
        self.frameSetting = QtWidgets.QFrame(Dialog)
        self.frameSetting.setGeometry(QtCore.QRect(0, 0, self.Scwidth, 300))
        #self.frameSetting.setGeometry(QtCore.QRect(192, 0, 640, 290))
        self.frameSetting.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameSetting.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameSetting.setObjectName("frameSetting")
        self.frameSetting.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameSetting.hide()
        self.widget2 = QtWidgets.QWidget(self.frameSetting)
        #self.widget2.setGeometry(QtCore.QRect(20, 21, 600, 141))
        #self.widget2.setGeometry(QtCore.QRect(212, 21, 600, 141))
        self.widget2.setGeometry(QtCore.QRect(20, 20, 700, 140))
        self.widget2.setObjectName("widget2")
        self.gridLayout_3 = QtWidgets.QGridLayout(self.widget2)
        self.gridLayout_3.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_3.setObjectName("gridLayout_3")
        self.lblStaff = QtWidgets.QLabel(self.widget2)
        self.lblStaff.setObjectName("lblStaff")
        self.gridLayout_3.addWidget(self.lblStaff, 0, 0, 1, 1)
        self.lineStaff = QtWidgets.QLineEdit(self.widget2)
        self.lineStaff.setObjectName("lineStaff")
        self.lineStaff.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineStaff, 0, 1, 1, 2)
        self.lblMenu1 = QtWidgets.QLabel(self.widget2)
        self.lblMenu1.setObjectName("lblMenu1")
        self.gridLayout_3.addWidget(self.lblMenu1, 1, 0, 1, 1)
        self.lineKode1 = QtWidgets.QLineEdit(self.widget2)
        self.lineKode1.setObjectName("lineKode1")
        self.lineKode1.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineKode1, 1, 1, 1, 1)
        self.lblMenu2 = QtWidgets.QLabel(self.widget2)
        self.lblMenu2.setObjectName("lblMenu2")
        self.gridLayout_3.addWidget(self.lblMenu2, 2, 0, 1, 1)
        self.lineKode2 = QtWidgets.QLineEdit(self.widget2)
        self.lineKode2.setObjectName("lineKode2")
        self.lineKode2.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineKode2, 2, 1, 1, 1)
        self.widget3 = QtWidgets.QWidget(self.frameSetting)
        #self.widget3.setGeometry(QtCore.QRect(504, 255, 500, 30))
        self.widget3.setGeometry(QtCore.QRect(self.Scwidth-550, 255, 500, 30))
        self.widget3.setObjectName("widget3")
        self.gridLayout_4 = QtWidgets.QGridLayout(self.widget3)
        self.gridLayout_4.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_4.setObjectName("gridLayout_4")
        self.CancelSaveBtn = QtWidgets.QPushButton(self.widget3)
        self.CancelSaveBtn.setObjectName("CancelSaveBtn")
        self.CancelSaveBtn.clicked.connect(self.CancelSettingClicked)
        self.CancelSaveBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.gridLayout_4.addWidget(self.CancelSaveBtn, 0, 2, 1, 1)
        self.SaveBtn = QtWidgets.QPushButton(self.widget3)
        self.SaveBtn.setObjectName("SaveBtn")
        self.SaveBtn.clicked.connect(self.SaveSettingClicked)
        self.SaveBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.gridLayout_4.addWidget(self.SaveBtn, 0, 3, 1, 1)
        self.widget4 = QtWidgets.QWidget(self.frameSetting)
        self.widget4.setGeometry(QtCore.QRect(20, 170, 700, 30))
        self.widget4.setObjectName("widget4")
        self.gridLayoutGB = QtWidgets.QGridLayout(self.widget4)
        self.gridLayoutGB.setContentsMargins(0, 0, 0, 0)
        self.gridLayoutGB.setObjectName("gridLayoutGB")
        self.GBMode1=QtWidgets.QRadioButton(self.widget4)
        self.GBMode1.setText("Mode 1")
        self.gridLayoutGB.addWidget(self.GBMode1, 0, 0, 1, 1)
        self.GBMode2=QtWidgets.QRadioButton(self.widget4)
        self.GBMode2.setText("Mode2")
        self.gridLayoutGB.addWidget(self.GBMode2, 0, 1, 1, 1)
        self.widgetBtnSetting = QtWidgets.QWidget(self.frameSetting)
        self.widgetBtnSetting.setGeometry(QtCore.QRect(730, 20, 274, 140))
        self.widgetBtnSetting.setObjectName("widgetBtnSetting")
        self.gridLayoutBtnSetting = QtWidgets.QGridLayout(self.widgetBtnSetting)
        self.gridLayoutBtnSetting.setContentsMargins(0, 0, 0, 0)
        self.gridLayoutBtnSetting.setObjectName("gridLayoutBtnSetting")
        self.RefreshBGBtn = QtWidgets.QPushButton(self.widgetBtnSetting)
        self.RefreshBGBtn.setObjectName("RefreshBGBtn")
        self.RefreshBGBtn.clicked.connect(self.RefreshBGBtnClicked)
        self.RefreshBGBtn.setText("Refresh BG")
        self.RefreshBGBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.gridLayoutBtnSetting.addWidget(self.RefreshBGBtn, 1, 1, 1, 1)
        self.frameRefreshInfo = QtWidgets.QFrame(self.frameSetting)
        self.frameRefreshInfo.setGeometry(QtCore.QRect(312, 150, 400, 100))        
        self.frameRefreshInfo.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameRefreshInfo.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameRefreshInfo.setObjectName("frameRefreshInfo")
        self.frameRefreshInfo.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.lblRefreshInfo = QtWidgets.QLabel(self.frameRefreshInfo)
        self.lblRefreshInfo.setGeometry(QtCore.QRect(5, 5, 390, 60))
        font = QtGui.QFont()
        #font.setFamily("Quicksand Medium")
        font.setPointSize(14)
        self.lblRefreshInfo.setFont(font)
        self.lblRefreshInfo.setStyleSheet("color: rgb(0, 0, 0);")
        self.lblRefreshInfo.setAlignment(QtCore.Qt.AlignCenter)
        self.lblRefreshInfo.setObjectName("lblRefreshInfo")
        self.lblRefreshInfo.setText("Keterangan Refresh")
        self.RefreshInfoBtn = QtWidgets.QPushButton(self.frameRefreshInfo)
        self.RefreshInfoBtn.setObjectName("RefreshImgBtn")
        self.RefreshInfoBtn.setGeometry(QtCore.QRect(150, 70, 100, 25))
        self.RefreshInfoBtn.clicked.connect(self.CloseRefreshInfo)
        self.RefreshInfoBtn.setText("Close")
        self.RefreshInfoBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.frameRefreshInfo.hide()
        self.RefreshType=""
                
        self.channel1=6 #26
        self.channel2=13 #19
        self.channel3=19 #13
        self.channel4=26 #6
        self.channel5=18
        setPin(self.channel1, self.channel2, self.channel3, self.channel4, self.channel5)
        self.i=0
        self.TimerPay=QTimer()
        self.TimerPay.setInterval(1000)
        self.TimerPay.timeout.connect(self.TimerPayOn)
        self.j=0
        self.TimerStatus=QTimer()
        self.TimerStatus.setInterval(100)
        self.TimerStatus.timeout.connect(self.TimerStatusOn)
        self.k=0
        self.TimerInternet=QTimer()
        self.TimerInternet.setInterval(1000)
        self.TimerInternet.timeout.connect(self.TimerInternetOn)
        self.TimerInternet.start()
        self.l=0
        self.TimerProgress=QTimer()
        self.TimerProgress.setInterval(250)
        self.TimerProgress.timeout.connect(self.TimerProgressOn)
        self.q=0
        self.TimerRefreshInfo=QTimer()
        self.TimerRefreshInfo.setInterval(500)
        self.TimerRefreshInfo.timeout.connect(self.TimerRefreshInfoOn)
        
        self.fileVersi="/home/pi/Documents/OmegaLaundry/Versi.txt"
        self.Versi=""
        if CheckFile(self.fileVersi):
            with open(self.fileVersi) as search:
                for line in search:
                    line=line.rstrip()
                    if "Versi" in line :
                        self.Versi=line.replace("Versi=", "")
        else :
            self.Versi="Unknown"            
        self.lblVersion.setText("V."+self.Versi)
        
        self.Staff = '0059D/01/00'
        self.Status = ''
        self.TrxId = ''
        self.JasaSelected = '01/000001'
        self.Jasa1= ''
        self.Jasa2= ''
        self.Mode = ''
        self.PaySelected = ''
        self.IsException = False
        self.UserID = "admin"
        self.Password = "omega"
        self.fileSetting="/home/pi/Documents/OmegaLaundry/Setting.txt"
        self.fileSettingBackup="/home/pi/Documents/OmegaLaundry/SettingBackup.txt"
        
        #self.GetResolution()
        self.InitialReadSetting()
        
        self.retranslateUi(Dialog)
        QtCore.QMetaObject.connectSlotsByName(Dialog)
        
    def MulaiClick(self):
        self.lblMulaiBtn.show()
        self.Status = 'start'
        self.JasaSelected=self.Jasa1
        self.l=0
        self.TimerProgress.start()
        #self.CekTipePayment()
        
    def Jasa1Click(self):
        self.lblJasa1Btn.show()
        self.Status = 'start'
        self.JasaSelected=self.Jasa1
        self.l=0
        self.TimerProgress.start()
        
    def Jasa2Click(self):
        self.lblJasa2Btn.show()
        self.Status = 'start'
        self.JasaSelected=self.Jasa2
        self.l=0
        self.TimerProgress.start()
    
    def LaundromatClick(self):
        self.lblLaundromatBtn.show()
        self.Status = 'laundromat'
        self.PaySelected = 'Laundromat'
        self.l=0
        self.TimerProgress.start()
        
    def QrisClick(self) :
        self.lblQrisBtn.show()
        self.Status = 'qris'
        self.PaySelected = 'Qris'
        self.l=0
        self.TimerProgress.start()
        
    def CancelClick(self) :
        if self.Status == "qris" or self.Status == 'laundromat' :
            self.TimerPay.stop()
            if self.lblWaitingPayment.isVisible():
                self.lblWaitingPayment.hide()
            if self.lblExceptionWarning.isVisible():
                self.lblExceptionWarning.hide()
            self.Status='cancel'
            self.l=0
            self.TimerProgress.start()
            #self.frameSinglePayment.hide()
            #self.frameMenu.show()
        elif self.Status == 'start' :
            self.framePayment.hide()
            self.GoToMainMenu()
            self.frameMenu.show()
            self.JasaSelected=''
            self.Status=''
        elif self.Status == 'info' :
            self.frameInformation.hide()
            self.GoToMainMenu()
            self.frameMenu.show()
            self.JasaSelected=''
            self.Status=''
        self.lblMulaiBtn.hide()
        self.lblJasa1Btn.hide()
        self.lblJasa2Btn.hide()
        self.lblLaundromatBtn.hide()
        self.lblQrisBtn.hide()
        
    def CekTipePayment(self):
        self.LaundromatBtn.hide()
        self.QrisBtn.hide()
        hasiltipe=ApiLaundry.CekTipePayment(self.Staff)
        print("Hasil tipe : "+hasiltipe)
        if "Terjadi Kesalahan" in hasiltipe:
            self.frameProgress.hide()
            self.lblInformation.setText("Terjadi kesalahan.\nSilahkan coba lagi")
            self.Status='info'
            self.GoToInfo()
            self.frameInformation.show()
            #self.frameMenu.show()
        else :
            if "Laundromat" in hasiltipe:
                self.LaundromatBtn.show()
            if "Qris" in hasiltipe:
                self.QrisBtn.show()
            self.frameProgress.hide()
            self.framePayment.show()
            
    def CreateQRPayment(self):
        self.TrxId, urlqr, qrraw = ApiLaundry.CreatePaymentJasa(self.Staff, self.JasaSelected, self.PaySelected)
        print("TrxId : "+self.TrxId + " , url : "+ urlqr)
        if self.TrxId == "Terjadi Kesalahan":
            self.frameProgress.hide() 
            self.lblInformation.setText("Terjadi kesalahan.\nSilahkan coba lagi")
            self.GoToInfo()
            self.frameInformation.show()
            self.Status='info'
            #self.frameMenu.show()
        else :    
            self.frameProgress.hide()
            self.lblQRSingle.hide()
            self.webSingleQR.hide()
            if self.PaySelected=='Laundromat':
            #if self.TrxId != "Terjadi Kesalahan" and urlqr != "Terjadi Kesalahan":
                img=pyqrcode.create(self.TrxId)
                img.svg('qrcodelm.svg', scale=5)
                self.lblQRSingle.setPixmap(QtGui.QPixmap("./qrcodelm.svg"))
                self.lblQRSingle.show()
            else :
                self.webSingleQR.setUrl(QtCore.QUrl(urlqr))
                self.webSingleQR.show()
            self.CancelSinglePaymentBtn.show()
            self.GoToQR()
            self.frameSinglePayment.show()
            self.frameSinglePayment.raise_()
            cursor=QtGui.QCursor()
            #print(cursor.pos())
            cursor.setPos(0,0)
            self.IsException=False
            self.i=0
            self.TimerPay.start()
        
    def CancelQR(self):
        coba=0
        while coba<=3 :
            hasilcancel=ApiLaundry.CancelPayment(self.TrxId, self.PaySelected)
            print("cancel "+hasilcancel)
            if hasilcancel=='Dibatalkan':
                coba=4
            else :
                coba+=1
        self.frameProgress.hide()
        self.lblInformation.setText("Pembelian Dibatalkan")
        self.Status='info'
        self.GoToInfo()
        self.frameInformation.show()
        #self.frameMenu.show()            
        
    def TimerInternetOn(self):
        hostname="www.telkom.co.id"
        if self.k%5==0:
            speedtest = pyspeedtest.SpeedTest(hostname)
            try :
                ping = speedtest.ping()
                ping = int(ping)
                checkinternet=True
            except :
                ping = 10000
                checkinternet=False
            #print("ping "+str(ping))
            #print(checkinternet)
            if checkinternet==True:            
                self.InternetBtn.setStyleSheet("QPushButton {background-color: green; color: white; border: none}")
            else :
                self.InternetBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}")
            
            if ping <=50:
                strRange="100%"
            elif ping >50 and ping <=100:
                strRange="75%"
            elif ping >100 and ping <=200:
                strRange="50%"
            elif ping >200 and ping <=300:
                strRange="25%"
            elif ping >300 :
                strRange="0%"
            self.lblInternetPercent.setText(strRange)
            self.k+=1
            
    def TimerPayOn(self):
        self.lblWaitingPayment.setText("Menunggu Pembayaran\n"+str(self.i//60).zfill(2)+":"+str(self.i%60).zfill(2))
        #self.lblWaitingPaymnet.show()
        if self.i % 2 == 0 :
            print("Menunggu pembayaran ",self.i, " "+self.TrxId)
            if self.Status=='qris' :
                hasilcekstatus=ApiLaundry.CekPayment(self.TrxId, "")
            elif self.Status=='laundromat' :
                hasilcekstatus=ApiLaundry.CekPayment(self.TrxId, "Laundromat")
            print(hasilcekstatus)
            if hasilcekstatus=="Terbayar":
                if self.IsException==True:
                    self.IsException=False
                    self.lblExceptionWarning.hide()
                self.lblWaitingPayment.hide()
                self.TimerPay.stop()
                self.frameSinglePayment.hide() 
                self.lblInformation.setText("Pembelian Berhasil.")
                self.BackToMainBtn.hide()
                self.GoToInfo()
                self.frameInformation.show()
                self.Status='info'
                self.j=0
                self.TimerStatus.start()
            elif hasilcekstatus=="Belum":
                self.lblWaitingPayment.show()
                if self.IsException==True:
                    self.IsException=False
                    self.lblExceptionWarning.hide()
                if self.i>=180 :
                    if self.lblWaitingPayment.isVisible():
                        self.lblWaitingPayment.hide()
                    self.CancelClick()
            else:
                self.IsException = True
                self.lblExceptionWarning.show()
                if self.lblWaitingPayment.isVisible():
                    self.lblWaitingPayment.hide()
        self.i+=1

            
    def TimerStatusOn(self):
        if self.j==0:
            if self.JasaSelected==self.Jasa1:
                ConnectRelay(self.channel1)
            elif self.JasaSelected==self.Jasa2:
                ConnectRelay(self.channel2)
        elif self.j==30:
            if self.JasaSelected==self.Jasa1:
                DisconnectRelay(self.channel1)
            elif self.JasaSelected==self.Jasa2:
                DisconnectRelay(self.channel2)
            if self.BackToMainBtn.isVisible()==False:
                self.BackToMainBtn.show()
            self.TimerStatus.stop()
        self.j+=1
        
    def TimerProgressOn(self):
        if self.l==0 :
            if self.Status=="start":
                self.lblInfoProgress.setText("Mengambil Mode Pembayaran.\nMohon Tunggu..")
                self.frameMenu.hide()
            elif self.Status=="qris":
                self.lblInfoProgress.setText("Mengambil QR Code QRIS.\nMohon Tunggu..")
                self.framePayment.hide()
            elif self.Status=="laundromat":
                self.lblInfoProgress.setText("Mengambil QR Code Laundromat Pay.\nMohon Tunggu..")
                self.framePayment.hide()
            elif self.Status=="cancel":
                self.lblInfoProgress.setText("Membatalkan Pembelian.\nMohon Tunggu..")
                self.frameSinglePayment.hide()
            self.GoToProgress()
            self.frameProgress.show()
        elif self.l==1 :
            if self.Status=="start":
                self.CekTipePayment()
            elif self.Status=="qris":
                self.CreateQRPayment()
                #print("get qr qris")
                #self.frameProgress.hide()
                #self.frameMenu.show()
            elif self.Status=="laundromat":
                self.CreateQRPayment()
                #print("get qr laundromat")
                #self.frameProgress.hide()
                #self.frameMenu.show()
            elif self.Status=="cancel" :
                self.CancelQR()
            self.TimerProgress.stop()
        self.l+=1
        
    def LogoClicked(self):
        vis = self.frameLogin.isVisible()
        if vis:
            self.frameLogin.hide()
            self.lineUserID.setText("")
            self.linePassword.setText("")
            self.frameKeyboard.hide()
            if self.IsInternetClicked==True:
                self.IsInternetClicked=False
        else :
            self.frameLogin.show()
            self.lineUserID.setFocus()
            self.frameKeyboard.show()
            self.frameLogin.raise_()
            self.frameKeyboard.raise_()
            
    def LoginClicked(self):
        inputuserid=self.lineUserID.text()
        inputuserid=inputuserid.rstrip("\n")
        inputpass=self.linePassword.text()
        inputpass=inputpass.rstrip("\n")
        if inputuserid == self.UserID and inputpass == self.Password :
            self.lineUserID.setText("")
            self.linePassword.setText("")
            self.frameLogin.hide()
            if self.IsInternetClicked==True:
                self.frameKeyboard.hide()  
                self.IsInternetClicked=False
                Dialog.showMinimized()
            else :
                self.lineStaff.setText(self.Staff)
                self.lineKode1.setText(self.Jasa1)
                self.lineKode2.setText(self.Jasa2)
                if self.Mode=="1":
                    self.GBMode1.setChecked(True)
                elif self.Mode=="2" :
                    self.GBMode2.setChecked(True)
                self.lineStaff.setFocus()
                self.frameSetting.show()
        else :
            self.lineUserID.setText("")
            self.linePassword.setText("")
            
    def InternetBtnClicked(self):
        vis = self.frameLogin.isVisible()
        if vis:
            self.frameLogin.hide()
            self.lineUserID.setText("")
            self.linePassword.setText("")
            self.frameKeyboard.hide()
            if self.IsInternetClicked==True:
                self.IsInternetClicked=False    
        else :
            self.IsInternetClicked=True
            self.frameLogin.show()
            self.lineUserID.setFocus()
            self.frameKeyboard.show()
            self.frameLogin.raise_()
            self.frameKeyboard.raise_()
            
    def SaveSettingClicked(self):
        settingFile = open(self.fileSettingBackup, "w+") 
        settingFile.write("Staff : "+self.lineStaff.text()+"\n")
        settingFile.write("Jasa1 : "+self.lineKode1.text()+"\n")
        settingFile.write("Jasa2 : "+self.lineKode2.text()+"\n")
        if self.GBMode1.isChecked() :
            settingFile.write("Mode : 1")
            self.Mode="1"
        elif self.GBMode2.isChecked() :
            settingFile.write("Mode : 2")
            self.Mode="2"      
        
        settingFile = open(self.fileSetting, "w+") 
        settingFile.write("Staff : "+self.lineStaff.text()+"\n")
        settingFile.write("Jasa1 : "+self.lineKode1.text()+"\n")
        settingFile.write("Jasa2 : "+self.lineKode2.text()+"\n")
        if self.GBMode1.isChecked() :
            settingFile.write("Mode : 1")
            self.Mode="1"
        elif self.GBMode2.isChecked() :
            settingFile.write("Mode : 2")
            self.Mode="2"
        
        self.Staff = self.lineStaff.text()
        self.Staff = self.Staff.rstrip("\r\n")
        self.Kode1 = self.lineKode1.text()
        self.Kode1 = self.Kode1.rstrip("\r\n")
        self.Kode2 = self.lineKode2.text()
        self.Kode2 = self.Kode2.rstrip("\r\n")
        self.frameSetting.hide() 
        self.frameKeyboard.hide()
        self.RedrawMenu()
        
    def CancelSettingClicked(self):
        vis = self.frameSetting.isVisible()
        if vis :
            self.frameSetting.hide()
            self.lineStaff.setText("")
            self.lineKode1.setText("")
            self.lineKode2.setText("")
            self.frameKeyboard.hide()
            
    def RedrawMenu(self):
        self.MulaiBtn.hide()
        self.Jasa1Btn.hide()
        self.Jasa2Btn.hide()
        if self.Mode=="1":
            self.MulaiBtn.show()
        else :
            self.Jasa1Btn.show()
            self.Jasa2Btn.show()
    
    def InitialReadSetting(self):
        isconnect=self.CheckConnection()
        if isconnect :
            self.UpdateProgramV2()
            self.UpdateBGImage()
            self.UpdateBGImage2()
        self.fileExist=CheckFile(self.fileSetting)
        self.fileBackupExist=CheckFile(self.fileSettingBackup)
        if self.fileBackupExist :
            if self.fileExist==False :
                shutil.copy(self.fileSettingBackup, self.fileSetting)
                self.fileExist=CheckFile(self.fileSetting)
                
        if self.fileExist :
            with open(self.fileSetting) as search:
                for line in search:
                    line=line.rstrip()
                    if "Staff" in line :
                        self.Staff=line.replace("Staff : ", "")
                    elif "Jasa1" in line :
                        self.Jasa1=line.replace("Jasa1 : ", "")
                    elif "Jasa2" in line :
                        self.Jasa2=line.replace("Jasa2 : ", "")
                    elif "Mode" in line :
                        self.Mode=line.replace("Mode : ", "")
        else :            
            self.Staff = ""
            self.Jasa1 = ""
            self.Jasa2 = ""
            self.Mode ="1"
        self.RedrawMenu()
            
    def KeyboardClicked(self, index):
        widgetname=QtWidgets.QApplication.focusWidget().objectName()
        linetext=QtWidgets.QApplication.focusWidget()
        if widgetname=="lineUserID" or widgetname=="linePassword" or widgetname=="lineStaff" or widgetname=="lineKode1" or widgetname=="lineKode2" :
            if self.CapsOn==True :
                keyboard=self.buttons2[index]
            else :
                keyboard=self.buttons[index]
            if keyboard=="Space":
                linetext.setText(linetext.text()+" ")
            elif keyboard=="Ent":
                #print("press Enter")
                if widgetname=="lineUserID" or widgetname=="linePassword":
                    self.LoginClicked()
                elif widgetname=="lineStaff" or widgetname=="lineKode1" or widgetname=="lineKode2"  :
                    self.SaveSettingClicked()                
            elif keyboard=="Alt":
                print("press Alt")
            elif keyboard=="Ctrl":
                #print("press Ctrl")
                self.CtrlOn= not self.CtrlOn
            elif keyboard=="Shft":
                #print("press Shft")
                self.ShiftOn = not self.ShiftOn
                self.CapsOn = not self.CapsOn
                self.RedrawKeyboard()
            elif keyboard=="Tab":
                #print("press Tab")
                if widgetname=="lineUserID":
                    self.linePassword.setFocus()
                elif widgetname=="linePassword":
                    self.lineUserID.setFocus()
                elif widgetname=="lineStaff":
                    self.lineKode1.setFocus()
                elif widgetname=="lineKode1":
                    self.lineKode2.setFocus()
                elif widgetname=="lineKode2":
                    self.lineStaff.setFocus()
            elif keyboard=="Caps":
                #print("press Caps")
                self.CapsOn = not self.CapsOn
                self.RedrawKeyboard()
            elif keyboard=="<-":
                linetext.backspace()
            else :
                if self.CtrlOn==True:
                    if (keyboard=="c") or (keyboard=="C"):
                        linetext.copy()
                    elif keyboard=="x" or keyboard=="X":
                        linetext.cut()
                    elif keyboard=="v" or keyboard=="V":
                        linetext.paste()
                    self.CtrlOn=False
                else :
                    if (self.CapsOn==True) :
                        linetext.setText(linetext.text()+self.buttons2[index])
                    else :
                        linetext.setText(linetext.text()+self.buttons[index])
                    if self.ShiftOn :
                        self.ShiftOn=not self.ShiftOn
                        self.CapsOn=not self.CapsOn
                        self.RedrawKeyboard()
                        
    def RedrawKeyboard(self):        
        for x in range(len(self.buttons)) :
            if (self.CapsOn==True) :
                txtKey=self.buttons2[x]
            else :
                txtKey=self.buttons[x]
            self.btn[x].setText(txtKey)
            
    def UpdateProgramV2(self):
        mainpy="/home/pi/Documents/OmegaLaundry/MainLaundry.py"
        versitxt="/home/pi/Documents/OmegaLaundry/Versi.txt"
        apiso="/home/pi/Documents/OmegaLaundry/ApiLaundry.cpython-37m-arm-linux-gnueabihf.so"
        bumainpy="/home/pi/Documents/OmegaLaundry/MainLaundryBU.py"
        buversitxt="/home/pi/Documents/OmegaLaundry/VersiBU.txt"
        buapiso="/home/pi/Documents/OmegaLaundry/ApiLaundry.cpython-37m-arm-linux-gnueabihfBU.so"
        if CheckFile(mainpy) and CheckFile(versitxt) and CheckFile(apiso):
            shutil.copy(mainpy, bumainpy)
            shutil.copy(versitxt, buversitxt)
            shutil.copy(apiso, buapiso)
        try :
            #check versi
            vercurrent=0
            encoding="utf-8"
            data = urlopen("http://www.omegasoft.co.id/download/IOT/Laundry/Versi.txt")
            for line in data :
                verprog=str(line, encoding)
                verprog=verprog.replace("Versi=", "")
                #print("Update Version : "+verprog)                
            fileExist=os.path.isfile("/home/pi/Documents/OmegaLaundry/Versi.txt")
            if fileExist :
                with open("/home/pi/Documents/OmegaLaundry/Versi.txt") as search:
                    for line in search:
                        line=line.rstrip()
                        vercurrent=line.replace("Versi=","")
                       # print("Current Version : "+vercurrent)                     
            print("Current-Web : "+vercurrent+"-"+verprog) 
            
            if int(verprog)>int(vercurrent) :
                print("Update Program Start")
                url="http://www.omegasoft.co.id/download/IOT/Laundry/Versi.txt"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaLaundry/Versi.txt", "wb") as f:
                    f.write(datatowrite)
                url="http://www.omegasoft.co.id/download/IOT/Laundry/MainLaundry.py"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaLaundry/MainLaundry.py", "wb") as f:
                    f.write(datatowrite)
                url="http://www.omegasoft.co.id/download/IOT/Laundry/ApiLaundry.cpython-37m-arm-linux-gnueabihf.so"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaLaundry/ApiLaundry.cpython-37m-arm-linux-gnueabihf.so", "wb") as f:
                    f.write(datatowrite)
                #st=os.stat("/home/pi/Documents/OmegaCoffee/MainCoffee.py")
                #os.chmod("/home/pi/Documents/OmegaCoffee/MainCoffee.py", st.st_mode | stat.S_IEXEC)
                print("Update Finished")
                print("Reboot")
                os.system("sudo shutdown -r now")
            else :
                print("Not Updating")
            #delete file backup
            if CheckFile(bumainpy) and CheckFile(buversitxt) and CheckFile(buapiso):
                os.remove(buversitxt)
                os.remove(buapiso)
                os.remove(bumainpy)
        except Exception as e :
            #kembalikan ke versi sebelumnya jika terjadi error saat update
            if CheckFile(bumainpy) and CheckFile(buversitxt) and CheckFile(buapiso):
                shutil.copy(bumainpy, mainpy)
                shutil.copy(buversitxt, versitxt)
                shutil.copy(buapiso, apiso)
                os.remove(buversitxt)
                os.remove(buapiso)
                os.remove(bumainpy)
            print("Terjadi kesalahan "+e.__class__.__name__)

    def GetResolution(self):
        width = Dialog.frameGeometry().width()
        height = Dialog.frameGeometry().height()
        print("W:"+str(width)+" H:"+str(height))
        
    def UpdateProgramV2(self):
        mainpy="/home/pi/Documents/OmegaLaundry/MainLaundry.py"
        versitxt="/home/pi/Documents/OmegaLaundry/Versi.txt"
        apiso="/home/pi/Documents/OmegaLaundry/ApiLaundry.cpython-37m-arm-linux-gnueabihf.so"
        bumainpy="/home/pi/Documents/OmegaLaundry/MainLaundryBU.py"
        buversitxt="/home/pi/Documents/OmegaLaundry/VersiBU.txt"
        buapiso="/home/pi/Documents/OmegaLaundry/ApiLaundry.cpython-37m-arm-linux-gnueabihfBU.so"
        if CheckFile(mainpy) and CheckFile(versitxt) and CheckFile(apiso):
            shutil.copy(mainpy, bumainpy)
            shutil.copy(versitxt, buversitxt)
            shutil.copy(apiso, buapiso)
        try :
            #check versi
            vercurrent=0
            encoding="utf-8"
            data = urlopen("http://www.omegasoft.co.id/download/IOT/Laundry/Versi.txt")
            for line in data :
                verprog=str(line, encoding)
                verprog=verprog.replace("Versi=", "")
                #print("Update Version : "+verprog)                
            fileExist=os.path.isfile("/home/pi/Documents/OmegaLaundry/Versi.txt")
            if fileExist :
                with open("/home/pi/Documents/OmegaLaundry/Versi.txt") as search:
                    for line in search:
                        line=line.rstrip()
                        vercurrent=line.replace("Versi=","")
                       # print("Current Version : "+vercurrent)                     
            print("Current-Web : "+vercurrent+"-"+verprog) 
            
            if int(verprog)>int(vercurrent) :
                print("Update Program Start")
                url="http://www.omegasoft.co.id/download/IOT/Laundry/Versi.txt"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaLaundry/Versi.txt", "wb") as f:
                    f.write(datatowrite)
                url="http://www.omegasoft.co.id/download/IOT/Laundry/MainLaundry.py"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaLaundry/MainLaundry.py", "wb") as f:
                    f.write(datatowrite)
                url="http://www.omegasoft.co.id/download/IOT/Laundry/ApiLaundry.cpython-37m-arm-linux-gnueabihf.so"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaLaundry/ApiLaundry.cpython-37m-arm-linux-gnueabihf.so", "wb") as f:
                    f.write(datatowrite)
                #st=os.stat("/home/pi/Documents/OmegaCoffee/MainCoffee.py")
                #os.chmod("/home/pi/Documents/OmegaCoffee/MainCoffee.py", st.st_mode | stat.S_IEXEC)
                print("Update Finished")
                print("Reboot")
                os.system("sudo shutdown -r now")
            else :
                print("Not Updating")
            #delete file backup
            if CheckFile(buversitxt) :
                os.remove(buversitxt)
            if CheckFile(buapiso) :
                os.remove(buapiso)
            if CheckFile(bumainpy):
                os.remove(bumainpy)
        except Exception as e :
            #kembalikan ke versi sebelumnya jika terjadi error saat update
            if CheckFile(buversitxt) :
                shutil.copy(buversitxt, versitxt)
                os.remove(buversitxt)
            if CheckFile(buapiso) :
                shutil.copy(buapiso, apiso)
                os.remove(buapiso)
            if CheckFile(bumainpy):
                shutil.copy(bumainpy, mainpy)
                os.remove(bumainpy)
            print("Terjadi kesalahan "+e.__class__.__name__)
            
    def UpdateBGImage(self):
        isnewfile=False
        updatepicture=False
        if CheckFile("/home/pi/Documents/OmegaLaundry/PictureData.txt") == False:
            isnewfile = True
            updatepicture = True
            linkBG="http://www.omegasoft.co.id/download/IOT/Laundry/BGAll.jpg"
            dirBG="/home/pi/Documents/OmegaLaundry/Img/BGAll.jpg"
        else :
            isnewfile=False
            try :
                print("compare web data and current data")
                imgdatecabang=""
                with open("/home/pi/Documents/OmegaLaundry/PictureData.txt") as search:
                    for line in search:
                        line=line.rstrip()
                        if "Date=" in line :
                            imgdate=line.replace("Date=","")
                            print("Current Image Date : "+imgdate)
                        elif "Date"+self.Staff[0:5]+"=" in line:
                            imgdatecabang=line.replace("Date"+self.Staff[0:5]+"=", "")
                            print("Current Image Cabang Date : "+imgdatecabang)
                
                webdatecabang=""
                encoding="utf-8"
                data = urlopen("http://www.omegasoft.co.id/download/IOT/Laundry/PictureData.txt")
                for line in data :
                    webline=str(line, encoding)
                    webline=webline.rstrip()
                    if "Date=" in webline :
                        webdate=webline.replace("Date=","")
                        print("Web Image Date : "+webdate)
                    elif "ImgBG=" in webline :
                        linkBG="http://www.omegasoft.co.id/download/IOT/Laundry/"+ webline.replace("ImgBG=", "")
                        dirBG="/home/pi/Documents/OmegaLaundry/Img/"+ webline.replace("ImgBG=", "")
                    elif "Date"+self.Staff[0:5]+"=" in webline:
                        webdatecabang=webline.replace("Date"+self.Staff[0:5]+"=", "")
                        print("Web Image Cabang Date : "+webdatecabang)
                    elif "ImgBG"+self.Staff[0:5] +"=" in webline :
                        linkBGcabang="http://www.omegasoft.co.id/download/IOT/Laundry/"+ webline.replace("ImgBG"+self.Staff[0:5]+"=", "")
                        dirBGcabang="/home/pi/Documents/OmegaLaundry/Img/"+ webline.replace("ImgBG"+self.Staff[0:5]+"=", "")                  
                dateimg=time.mktime(time.strptime(imgdate, "%d%b%Y"))
                if webdatecabang!="":
                    if imgdatecabang=="":
                        updatepicture=True
                    else :
                        dateimg=time.mktime(time.strptime(imgdatecabang, "%d%b%Y"))
                    dateweb=time.mktime(time.strptime(webdatecabang, "%d%b%Y"))
                    linkBG=linkBGcabang
                    dirBG=dirBGcabang
                else :
                    dateweb=time.mktime(time.strptime(webdate, "%d%b%Y"))
                
                if webdatecabang!="" and imgdatecabang=="":
                    updatepicture=True
                else :
                    if dateimg < dateweb :
                        updatepicture=True
                    else :
                        updatepicture=False
            except Exception as e :
                print("Gagal pengecekan data image : "+e.__class__.__name__)
                updatepicture=False
                
        if isnewfile :
            try:
                print("cek picture data new")
                param="ImgBG"+self.Staff[0:5]+"="
                print(param)
                linkBGcabang=""
                encoding="utf-8"
                data = urlopen("http://www.omegasoft.co.id/download/IOT/Laundry/PictureData.txt")
                for line in data :
                    webline=str(line, encoding)
                    webline=webline.rstrip()
                    if "ImgBG=" in webline :
                        print(webline)
                        linkBG="http://www.omegasoft.co.id/download/IOT/Laundry/"+ webline.replace("ImgBG=", "")
                        dirBG="/home/pi/Documents/OmegaLaundry/Img/"+ webline.replace("ImgBG=", "")
                    elif param in webline :    
                        print(webline)
                        linkBGcabang="http://www.omegasoft.co.id/download/IOT/Laundry/"+ webline.replace(param, "")
                        dirBGcabang="/home/pi/Documents/OmegaLaundry/Img/"+ webline.replace(param, "")
                
                print(linkBGcabang)
                if linkBGcabang!="":
                    linkBG=linkBGcabang
                    print(linkBG)
                    dirBG=dirBGcabang
            except Exception as e :
                print("Gagal mengecek file baru "+e.__class__.__name__)
                
        if updatepicture :
            print("Updating BG Image")
            try :
                print("Get Picture Data")
                url="http://www.omegasoft.co.id/download/IOT/Laundry/PictureData.txt"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaLaundry/PictureData.txt", "wb") as f:
                    f.write(datatowrite)
                print("Get Img BG : "+linkBG)
                Picture_request = requests.get(linkBG)
                with open(dirBG, "wb") as f:
                    f.write(Picture_request.content)        
            except Exception as e :
                print("Gagal Update Picture : "+e.__class__.__name__)
        else:
            print("Not Updating BG Image")
        self.imageBG=dirBG
        self.imageBGHome=dirBG
        self.imageBGQR=dirBG
        self.imageBGInfo=dirBG
        self.imageBGProgress=dirBG
        print(self.imageBG)
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBGHome))
        
    def UpdateBGImage2(self):
        try :
            print("get all bg")
            bgdate=""
            qrdate=""
            infodate=""
            progdate=""
            update1=False
            update2=False
            update3=False
            update4=False
            if CheckFile("/home/pi/Documents/OmegaCoffee/BGData.txt") :
                with open("/home/pi/Documents/OmegaCoffee/BGData.txt") as search:
                    for line in search:
                        line=line.rstrip()
                        if "BGDate=" in line :
                            bgdate=line.replace("BGDate=","")
                            #print("Current BG Date : "+bgdate) 
                        elif "QRDate=" in line :
                            qrdate=line.replace("QRDate=","")
                            #print("Current QR Date : "+qrdate)                        
                        elif "InfoDate=" in line :
                            infodate=line.replace("InfoDate=","")
                            #print("Current Info Date : "+infodate)
                        elif "ProgDate=" in line :
                            progdate=line.replace("ProgDate=","")
                            #print("Current Prog Date : "+progdate)                
                #print("Current BG Date : "+bgdate)
                #print("Current QR Date : "+qrdate)
                #print("Current Info Date : "+infodate)
                #print("Current Prog Date : "+progdate)                
            r=requests.post("http://api-prod.omegasoft.co.id/v3/Iot_omega/detailgambariot", data={'token':'ojdhKKlhdbsmd2345djjshdjsdhjhjjfsf', 'UID':'2308jdhjhsjshfJJkshdkwrvsuonzMMh', 'branch':self.Staff[0:5], 'tipeiot':'LAUNDRY'})
            result=json.loads(r.text)
            print(result)
            listgbr=result.get("data")
            if len(listgbr)> 0 :
                dirgbr1="/home/pi/Documents/OmegaCoffee/Img/BGHome.jpg"
                dirgbr2="/home/pi/Documents/OmegaCoffee/Img/BGQR.jpg"
                dirgbr3="/home/pi/Documents/OmegaCoffee/Img/BGInfo.jpg"
                dirgbr4="/home/pi/Documents/OmegaCoffee/Img/BGProgress.jpg"
                gbr1=result.get("data")["Gambar1"]
                date1=result.get("data")["TglGambar1"]
                gbr2=result.get("data")["Gambar2"]
                date2=result.get("data")["TglGambar2"]
                gbr3=result.get("data")["Gambar3"]
                date3=result.get("data")["TglGambar3"]
                gbr4=result.get("data")["Gambar4"]
                date4=result.get("data")["TglGambar4"]
                
                if bgdate=="":
                    update1=True
                else :
                    time1=time.mktime(time.strptime(bgdate, "%Y-%m-%d %H:%M:%S"))
                    time2=time.mktime(time.strptime(date1, "%Y-%m-%d %H:%M:%S"))
                    if time2 > time1 :
                        update1=True
                if qrdate=="":
                    update2=True
                else :
                    time1=time.mktime(time.strptime(qrdate, "%Y-%m-%d %H:%M:%S"))
                    time2=time.mktime(time.strptime(date2, "%Y-%m-%d %H:%M:%S"))
                    if time2 > time1 :
                        update2=True
                if infodate=="":
                    update3=True
                else :
                    time1=time.mktime(time.strptime(infodate, "%Y-%m-%d %H:%M:%S"))
                    time2=time.mktime(time.strptime(date3, "%Y-%m-%d %H:%M:%S"))
                    if time2 > time1 :
                        update3=True
                if progdate=="":
                    update4=True
                else :
                    time1=time.mktime(time.strptime(progdate, "%Y-%m-%d %H:%M:%S"))
                    time2=time.mktime(time.strptime(date4, "%Y-%m-%d %H:%M:%S"))
                    if time2 > time1 :
                        update4=True
                        
                #print(gbr1)
                if update1 :
                    if gbr1=="" :
                        self.imageBGHome=self.imageBG
                    else :
                        urlname1="http://omegasoft.co.id/images/"+gbr1                
                        print("Get image bg home "+urlname1)
                        Picture_request = requests.get(urlname1)
                        with open(dirgbr1, "wb") as f:
                            f.write(Picture_request.content)
                        self.imageBGHome=dirgbr1
                #print(gbr2)
                if update2 :
                    if gbr2=="" :
                        self.imageBGQR=self.imageBG
                    else :
                        urlname2="http://omegasoft.co.id/images/"+gbr2                
                        print("Get image bg qr "+urlname2)
                        Picture_request = requests.get(urlname2)
                        with open(dirgbr2, "wb") as f:
                            f.write(Picture_request.content)
                        self.imageBGQR=dirgbr2
                #print(gbr3)
                if update3 :
                    if gbr3=="" :
                        self.imageBGInfo=self.imageBG
                    else :
                        urlname3="http://omegasoft.co.id/images/"+gbr3                
                        print("Get image bg info "+urlname3)
                        Picture_request = requests.get(urlname3)
                        with open(dirgbr3, "wb") as f:
                            f.write(Picture_request.content)
                        self.imageBGInfo=dirgbr3
                #print(gbr4)
                if update4 :
                    if gbr4=="" :
                        self.imageBGProgress=self.imageBG
                    else :
                        urlname4="http://omegasoft.co.id/images/"+gbr4                
                        print("Get image bg progress "+urlname4)
                        Picture_request = requests.get(urlname4)
                        with open(dirgbr4, "wb") as f:
                            f.write(Picture_request.content)
                        self.imageBGprogress=dirgbr4
                if update1 or update2 or update3 or update4 :
                    print("update BGData.txt")
                    bgFile = open("/home/pi/Documents/OmegaCoffee/BGData.txt", "w+") 
                    bgFile.write("BGDate="+date1+"\n")
                    bgFile.write("QRDate="+date2+"\n")
                    bgFile.write("InfoDate="+date3+"\n")
                    bgFile.write("ProgDate="+date4+"\n")
                if CheckFile("/home/pi/Documents/OmegaCoffee/BGData.txt"):
                    self.imageBGHome=dirgbr1
                    self.imageBGQR=dirgbr2
                    self.imageBGInfo=dirgbr3
                    self.imageBGprogress=dirgbr4
                self.lblBG.setPixmap(QtGui.QPixmap(self.imageBGHome))
                self.lblRefreshInfo.setText("Refreshing BG Image 2 Success")
                self.RefreshInfoBtn.show()
            else :
                print("no bg in db")
                self.RefreshInfoBtn.show()                
        except Exception as e :
            print(e.__class__.__name__)
            self.lblRefreshInfo.setText("Refreshing BG Image 2 Error")
            self.RefreshInfoBtn.show()
        self.RefreshBGBtn.setDisabled(False)
        
    def RefreshBGImage(self):
        IsError=False
        print("Start Refresh BG Image")
        if CheckFile("/home/pi/Documents/OmegaLaundry/PictureData.txt") == False:
            try :
                print("Get Picture Data")
                url="http://www.omegasoft.co.id/download/IOT/Laundry/PictureData.txt"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaLaundry/PictureData.txt", "wb") as f:
                    f.write(datatowrite)           
            except Exception as e :
                print("Gagal Get Picture Data "+ e.__class__.__name__)
                isError=True
        filebg=""
        filebgcabang=""
        with open("/home/pi/Documents/OmegaLaundry/PictureData.txt") as search:
            for line in search:
                line=line.rstrip()
                if "ImgBG=" in line :
                    filebg=line.replace("ImgBG=","")
                    print("BG Image : "+filebg)
                elif "ImgBG"+self.Staff[0:5]+"=" in line:
                    filebgcabang=line.replace("ImgBG"+self.Staff[0:5]+"=", "")
                    print("BG Image Cabang : "+filebgcabang)
        if filebgcabang!="" :
            linkBG="http://www.omegasoft.co.id/download/IOT/Laundry/"+filebgcabang
            dirBG="/home/pi/Documents/OmegaLaundry/Img/"+filebgcabang
            isError=False
        elif filebg!="" :
            linkBG="http://www.omegasoft.co.id/download/IOT/Laundry/"+filebg
            dirBG="/home/pi/Documents/OmegaLaundry/Img/"+filebg
            isError=False
        else :
            isError=True
        if isError==False : 
            try :
                print("Get Img BG : "+linkBG)
                Picture_request = requests.get(linkBG)
                with open(dirBG, "wb") as f:
                    f.write(Picture_request.content)                
                self.imageBG=dirBG
                self.imageBGHome=dirBG
                self.imageBGQR=dirBG
                self.imageBGInfo=dirBG
                self.imageBGprogress=dirBG
                print(self.imageBG)
                self.lblBG.setPixmap(QtGui.QPixmap(self.imageBG))
                self.lblRefreshInfo.setText("Refreshing BG Image Success")
            except Exception as e :
                print("Gagal Get Img BG "+ e.__class__.__name__)
                self.lblRefreshInfo.setText("Refreshing BG Image Failed")
        else:
            print("Gagal Refresh")
            self.lblRefreshInfo.setText("Refreshing BG Image Error")
        
    def TimerRefreshInfoOn(self):
        if self.q==1:
            if self.RefreshType=="BG" :
                self.RefreshBGImage()
        elif self.q==2:
            if self.RefreshType=="BG" :
                self.UpdateBGImage2()
            self.TimerRefreshInfo.stop()
        self.q+=1
        
    def RefreshBGBtnClicked(self):
        self.RefreshBGBtn.setEnabled(False)
        self.RefreshType="BG"
        self.lblRefreshInfo.setText("Refreshing Background Image\nPlease Wait...")
        self.RefreshInfoBtn.hide() 
        self.frameRefreshInfo.show()
        self.q=0
        self.TimerRefreshInfo.start()
        
    def CloseRefreshInfo(self):
        self.RefreshType=""
        self.TimerRefreshInfo.stop()
        self.frameRefreshInfo.hide()
        
    def CheckConnection(self):
        hasilcheck=False
        try:
            print("Check Connection :")
            host=socket.gethostbyname("1.1.1.1")
            s = socket.create_connection((host, 80), 1)
            s.close()
            hasilcheck=True
            print("Connect")
        except Exception as err:
            hasilcheck=False
            print("Not Connect "+ err.__class__.__name__)
        return hasilcheck
    
    def GoToMainMenu(self):
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBGHome))
        
    def GoToProgress(self):
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBGProgress))
        
    def GoToInfo(self):        
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBGInfo))
        
    def GoToQR(self):
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBGQR))

    def retranslateUi(self, Dialog):
        _translate = QtCore.QCoreApplication.translate
        Dialog.setWindowTitle(_translate("Dialog", "Laundry"))
        #self.MulaiBtn.setText(_translate("Dialog", "Mulai"))
        #self.Jasa1Btn.setText(_translate("Dialog", "Cuci"))
        #self.Jasa2Btn.setText(_translate("Dialog", "Kering"))
        #self.LaundromatBtn.setText(_translate("Dialog", "Laundromat"))
        #self.QrisBtn.setText(_translate("Dialog", "QRIS"))
        self.CancelSinglePaymentBtn.setText(_translate("Dialog", "Cancel"))
        self.CancelBtn.setText(_translate("Dialog", "Cancel"))
        self.BackToMainBtn.setText(_translate("Dialog", "Back to Menu"))
        self.lblUserID.setText(_translate("Dialog", "User"))
        self.lblPassword.setText(_translate("Dialog", "Password"))
        self.CancelLoginBtn.setText(_translate("Dialog", "Cancel"))
        self.LoginBtn.setText(_translate("Dialog", "Login"))
        self.lblStaff.setText(_translate("Dialog", "Staff"))
        self.lblMenu1.setText(_translate("Dialog", "Jasa 1"))
        self.lblMenu2.setText(_translate("Dialog", "Jasa 2"))
        self.CancelSaveBtn.setText(_translate("Dialog", "Cancel"))
        self.SaveBtn.setText(_translate("Dialog", "Save"))

from PyQt5 import QtWebKitWidgets

if __name__ == "__main__":
    import sys
    #AutoUpdate.UpdateProgram()
    app = QtWidgets.QApplication(sys.argv)
    Dialog = QtWidgets.QDialog()
    ui = Ui_Dialog()
    ui.setupUi(Dialog)
    Dialog.show()
    sys.exit(app.exec_())